/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.benutzerverwaltung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="RECHTE_KONFIGURATION.UK",
     query="SELECT o FROM RechteKonfiguration o WHERE "

                         + "o"
                +".rechtAsString"
              +" = ?1"

             +" AND "         + "o"
                +".mandant"
                +".nummer"
              +" = ?2"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="RECHTE_KONFIGURATION.All",
     query="SELECT o FROM RechteKonfiguration o WHERE o.mandant =?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "RECHTE_KONFIGURATION")
// @javax.persistence.IdClass(RechteKonfigurationPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class RechteKonfiguration
extends AbstractRechteKonfiguration
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public RechteKonfiguration() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public RechteKonfiguration(RechteKonfiguration original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "rechte_konfiguration_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "RechteKonfiguration")
    @javax.persistence.TableGenerator(name = "RechteKonfiguration", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "RechteKonfiguration", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient RechteKonfigurationPK pkCache;

  @Override
  public RechteKonfigurationPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new RechteKonfigurationPK(getId());
    }

    return pkCache;
  }

  public static <E extends RechteKonfiguration> java.util.Map<RechteKonfigurationPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<RechteKonfigurationPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends RechteKonfiguration> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedNurImTestmodusAktiv = false;
          hasChangedRechtAsString = false;
  
      hasChangedMandant = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "NUR_IM_TESTMODUS_AKTIV", nullable = RechteKonfigurationConstants.NUR_IM_TESTMODUS_AKTIV_NULLABLE)
    
  protected java.lang.Boolean nurImTestmodusAktiv =  false;

  @javax.persistence.Transient
  protected boolean hasChangedNurImTestmodusAktiv = false;

  public boolean hasChangedNurImTestmodusAktiv(){
    return hasChangedNurImTestmodusAktiv;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNurImTestmodusAktiv = false;
     @javax.persistence.Transient
     private transient java.lang.Boolean wertNachLadenNurImTestmodusAktiv;
  
  /**
   * 
   *
   * getter for RECHTE_KONFIGURATION.NUR_IM_TESTMODUS_AKTIV
   */
    @Override   public  java.lang.Boolean getNurImTestmodusAktiv() {
        return nurImTestmodusAktiv;
      }

  /**
   * 
   *
   * setter for RECHTE_KONFIGURATION.NUR_IM_TESTMODUS_AKTIV
   *
   * @param nurImTestmodusAktiv
   */
  @Override   public void setNurImTestmodusAktiv( java.lang.Boolean nurImTestmodusAktiv) {

       resetTkCache();
                  java.lang.Boolean nurImTestmodusAktivInternal = nurImTestmodusAktiv;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nurImTestmodusAktiv
      , nurImTestmodusAktivInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNurImTestmodusAktiv |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nurImTestmodusAktiv");
      }


             if (!isSeitLadenVeraendertNurImTestmodusAktiv) {
          isSeitLadenVeraendertNurImTestmodusAktiv = thisAttributChanged;
         if (isSeitLadenVeraendertNurImTestmodusAktiv){
           wertNachLadenNurImTestmodusAktiv=this.nurImTestmodusAktiv;
         }
       }
      

       this.nurImTestmodusAktiv = nurImTestmodusAktivInternal;

         }

        
      @javax.persistence.Column(name = "RECHT", nullable = RechteKonfigurationConstants.RECHT_NULLABLE, length=RechteKonfigurationConstants.RECHT_MAX_LENGTH)
        
  protected String rechtAsString =  null;

  @javax.persistence.Transient
  protected boolean hasChangedRechtAsString = false;

  public boolean hasChangedRechtAsString(){
    return hasChangedRechtAsString;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertRechtAsString = false;
     @javax.persistence.Transient
     private transient String wertNachLadenRechtAsString;
  
  /**
   * 
   *
   * getter for RECHTE_KONFIGURATION.RECHT
   */
    @Override   public  String getRechtAsString() {
        return rechtAsString;
      }

  /**
   * 
   *
   * setter for RECHTE_KONFIGURATION.RECHT
   *
   * @param rechtAsString
   */
  @Override   public void setRechtAsString( String rechtAsString) {

       resetTkCache();
                  
                          String rechtAsStringInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(rechtAsString, RechteKonfigurationConstants.RECHT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.rechtAsString
      , rechtAsStringInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedRechtAsString |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("rechtAsString");
      }


             if (!isSeitLadenVeraendertRechtAsString) {
          isSeitLadenVeraendertRechtAsString = thisAttributChanged;
         if (isSeitLadenVeraendertRechtAsString){
           wertNachLadenRechtAsString=this.rechtAsString;
         }
       }
      

       this.rechtAsString = rechtAsStringInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("RechteKonfiguration:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(RechteKonfiguration other){
                             other.nurImTestmodusAktiv = this.nurImTestmodusAktiv;
                                other.rechtAsString = this.rechtAsString;
           
  other.setMandant(this.getMandant());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(RechteKonfiguration.class)){
        copyEntityAttributesUsingSetter((RechteKonfiguration) other.castTo(RechteKonfiguration.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von RechteKonfiguration: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(RechteKonfiguration other){
               other.setNurImTestmodusAktiv(this.nurImTestmodusAktiv);
                  other.setRechtAsString(this.rechtAsString);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(RechteKonfiguration other){
                       if (hasChangedNurImTestmodusAktiv) {
        other.setNurImTestmodusAktiv(this.nurImTestmodusAktiv);
      }
                             if (hasChangedRechtAsString) {
        other.setRechtAsString(this.rechtAsString);
      }
             }





    @javax.persistence.Transient
    private transient RechteKonfigurationTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public RechteKonfigurationTK getRechteKonfigurationTK(){
    if (tkCache==null) {
    tkCache = new RechteKonfigurationTK(

getRechtAsString()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getRechteKonfigurationTK();
    }

  @Override
  public RechteKonfigurationUK getUk(){
    return getRechteKonfigurationUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return RechteKonfiguration.class;
  }

public RechteKonfigurationUK getRechteKonfigurationUK(){

   return  new RechteKonfigurationUK(

getRechtAsString()
,     getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient RechteKonfigurationProperties properties;

  public RechteKonfigurationProperties getProperties(){
    if (properties == null) {
      properties = new RechteKonfigurationProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public RechteKonfigurationProperties getRechteKonfigurationProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return RechteKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(RechteKonfigurationConstants.MESSAGE_KEY_NUR_IM_TESTMODUS_AKTIV_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(RechteKonfigurationConstants.MESSAGE_KEY_NUR_IM_TESTMODUS_AKTIV_EINZAHL);

        nurImTestmodusAktiv =
     vorher.getAttributTyp().getValueAsBoolean(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(RechteKonfigurationConstants.MESSAGE_KEY_RECHT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(RechteKonfigurationConstants.MESSAGE_KEY_RECHT_EINZAHL);

        rechtAsString =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertNurImTestmodusAktiv) {
      result.put(RechteKonfigurationConstants.MESSAGE_KEY_NUR_IM_TESTMODUS_AKTIV_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.BOOLEAN
                , wertNachLadenNurImTestmodusAktiv , nurImTestmodusAktiv));
    }
                            if (isSeitLadenVeraendertRechtAsString) {
      result.put(RechteKonfigurationConstants.MESSAGE_KEY_RECHT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenRechtAsString , rechtAsString));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertNurImTestmodusAktiv = false;
      wertNachLadenNurImTestmodusAktiv = null;
                          isSeitLadenVeraendertRechtAsString = false;
      wertNachLadenRechtAsString = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "RECHTE_KONFIGURATION";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "RechteKonfiguration";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(nurImTestmodusAktiv, this, RechteKonfigurationConstants.MESSAGE_KEY_NUR_IM_TESTMODUS_AKTIV_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(rechtAsString, this, RechteKonfigurationConstants.MESSAGE_KEY_RECHT_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(RechteKonfigurationConstants.RECHT_MAX_LENGTH , 1 ,  rechtAsString, this, RechteKonfigurationConstants.MESSAGE_KEY_RECHT_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
